ext WaitTimer_

Port_Register equ 44h
Port_Out equ 45h

Psg_Tone_A equ 0
Psg_Tone_B equ 2
Psg_Tone_C equ 4
Psg_Mixer equ 7
Psg_Volume_A equ 8
Psg_Volume_B equ 9
Psg_Volume_C equ 10

Opn_OnOff equ 28h
Opn_Part equ 30h

    dseg
tempo equ 220

PsgCount equ 3
OpnCount equ 3
AllCount equ PsgCount+OpnCount
Channel_Ptr equ 0
Channel_Start equ Channel_Ptr+2
Channel_Len equ Channel_Start+2
Channel_Vol equ Channel_Len+1
unitSize equ Channel_Vol+1

Channels defs unitSize*AllCount
time: defw 0
end_of_dseg: public end_of_dseg


cseg

WaitPort:
    push af
        do
            in a,(Port_Register)
            and 80h
        while nz | wend
    pop af
ret

; PianoTone:
;     defb 15,82,50,2
;     defb 65,27,0,0
;     defb 94,94,94,158
;     defb 15,8,7,8
;     defb 5,5,5,5
;     defb 214,214,216,216
;     defb 60
; LowTone:
;     defb 15,82,50,2
;     defb 65,27,0,0
;     defb 94,94,94,158
;     defb 25,8,7,8
;     defb 5,5,5,5
;     defb 214,214,216,216
;     defb 60
; BassTone:
;     defb 96,96,96,96
;     defb 23,23,63,0
;     defb 158,156,152,156
;     defb 14,4,10,5
;     defb 8,9,9,9
;     defb 182,198,198,198
;     defb 48
SnareTone:
    defb 15,0,0,0
    defb 14,19,17,0
    defb 31,31,31,31
    defb 0,24,15,19
    defb 0,0,17,16
    defb 8,184,44,44
    defb 60
; BassDrumTone:
;     defb 80,16,64,96
;     defb 0,0,12,12
;     defb 95,95,95,95
;     defb 31,20,13,19
;     defb 11,20,10,16
;     defb 248,10,12,12
;     defb 60


Bass equ 0

SetTone:
    ld b,24
    do
        call WaitPort
        ld a,c
        out (Port_Register),a
        ld a,(hl) | inc hl
        out (Port_Out),a
        inc c | inc c | inc c | inc c
    dwnz
    ld a,c | add a,20h
    out (Port_Register),a
    ld a,(hl) | inc hl
    out (Port_Out),a
ret

InitSound_: public InitSound_
    ld a,Psg_Mixer
    out (Port_Register),a
    ld a,038h
    out (Port_Out),a

    ld hl,Channels
    xor a
    ld b,AllCount*unitSize
    do
        ld (hl),a
        inc hl
    dwnz
    ld hl,0
    ld (time),hl

    ; ld hl,BassDrumTone
    ; ld c,Opn_Part
    ; call SetTone

    ; ld hl,PianoTone
    ; ld c,Opn_Part+1
    ; call SetTone

    ld hl,SnareTone
    ld c,Opn_Part+2
    call SetTone

    ld bc,OpnCount * 256
    do
        call WaitPort
        ld a,Opn_OnOff
        out (Port_Register),a
        ld a,(0)
        ld a,c
        out (Port_Out),a
        inc c
    dwnz
ret

ToneOn:
; in
;   hl : cycle
    push af
        ld a,Psg_Tone_A
        out (Port_Register),a
        ld a,l
        out (Port_Out),a
        ld a,Psg_Tone_A+1
        out (Port_Register),a
        ld a,h
        out (Port_Out),a
        ld a,Psg_Volume_A
        out (Port_Register),a
        ld a,15
        out (Port_Out),a
    pop af
ret

ToneOff:
    ld a,Psg_Volume_A
    out (Port_Register),a
    xor a
    out (Port_Out),a
ret


Sound_Get_: public Sound_Get_
Sound_Beep_: public Sound_Beep_
    push af | push hl | push de
        ld hl, 283
        call ToneOn
        ld a,2
        call WaitTimer_
        call ToneOff
    pop de | pop hl | pop af
ret


Sound_Hit_: public Sound_Hit_
    push af | push hl | push de
        ld hl, 300
        do
            Sound_Hit_.Loop:
            call ToneOn
            ld a,1
            call WaitTimer_
            ld de,-10
            add hl,de
            ld a,h
            or a
            jr nz,Sound_Hit_.Loop
            ld a,l
            cp 150
        while nz | wend
        call ToneOff
    pop de | pop hl | pop af
ret

; Sound_Miss_: public Sound_Miss_
;     push af | push hl | push de
;         ld hl, 150
;         do
;             Sound_Miss_Loop:
;             call ToneOn
;             ld a,1
;             call ToneWait
;             ld de,10
;             add hl,de
;             ld a,h
;             or a
;             jr z,Sound_Miss_Loop
;             ld a,l
;             cp 300-256
;         while nz | wend
;         call ToneOff
;     pop de | pop hl | pop af
; ret


Sound_Loose_: public Sound_Loose_
    push af | push hl | push de
        ld hl, 1000
        call ToneOn
        ld a,6
        call WaitTimer_
        call ToneOff
    pop de | pop hl | pop af
ret

SoundHandler_: public SoundHandler_
    push af | push hl | push de
        ld hl,(time)
        ld de,-tempo
        add hl,de
        if nc
            push hl | push bc | push ix
                ld ix,Channels
                ld bc,PsgCount * 100h ; b = count; c = register
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)
                        if z
                            continue:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                ld a,c
                                add a,Psg_Volume_A
                                out (Port_Register),a
                                xor a
                                out (Port_Out),a
                                jr next
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,cycles
                                add hl,de
                                ld a,c
                                add a,a
                                ld e,a
                                out (Port_Register),a
                                ld a,(hl)
                                out (Port_Out),a
                                inc hl
                                ld a,e
                                inc a
                                out (Port_Register),a
                                ld a,(hl)
                                out (Port_Out),a
                                ld (ix+Channel_Vol),15
                            else
                                ld (ix+Channel_Vol),0
                            endif
                        endif
                        ld a,c
                        add a,Psg_Volume_A
                        out (Port_Register),a
                        ld a,(ix+Channel_Vol)
                        out (Port_Out),a
                        or a
                        if nz
                            dec a
                            ld (ix+Channel_Vol),a
                        endif
                    endif
                    next:
                    inc c
                    ld de,unitSize
                    add ix,de
                dwnz

                ld bc,300h ; b = count; c = channel
                do
                    ld l,(ix+Channel_Ptr)
                    ld h,(ix+Channel_Ptr+1)
                    ld a,l
                    or h
                    if nz
                        dec (ix+Channel_Len)
                        if z
                            ld a,(ix+Channel_Vol)
                            or a
                            if nz
                                call WaitPort
                                ld a,Opn_OnOff
                                out (Port_Register),a
                                ld a,(0)
                                ld a,c
                                out (Port_Out),a
                                ld (ix+Channel_Vol),0
                            endif
                            continue2:
                            ld a,(hl)
                            or a
                            if z
                                ; end
                                ld (ix+Channel_Ptr),a
                                ld (ix+Channel_Ptr+1),a
                                ld a,c
                                add a,Psg_Volume_A
                                out (Port_Register),a
                                xor a
                                out (Port_Out),a
                                jr next2
                            endif
                            inc a
                            if z 
                                ; repeat
                                ld l,(ix+Channel_Start)
                                ld h,(ix+Channel_Start+1)
                                jr continue2
                            endif
                            dec a
                            ld (ix+Channel_Len),a
                            inc hl
                            ld a,(hl)
                            inc hl
                            ld (ix+Channel_Ptr),l
                            ld (ix+Channel_Ptr+1),h
                            or a
                            if nz
                                dec a
                                add a,a
                                ld e,a
                                ld d,0
                                ld hl,OpnScales
                                add hl,de
                                ld a,c
                                add a,0a4h
                                call WaitPort
                                out (Port_Register),a
                                ld a,(0)
                                ld a,(hl)
                                inc hl
                                out (Port_Out),a
                                call WaitPort
                                ld a,c
                                add a,0a0h
                                out (Port_Register),a
                                ld a,(0)
                                ld a,(hl)
                                out (Port_Out),a

                                call WaitPort
                                ld a,Opn_OnOff
                                out (Port_Register),a
                                ld a,(0)
                                ld a,c
                                or 0f0h
                                out (Port_Out),a
                                ld (ix+Channel_Vol),0ffh
                            endif
                        endif
                    endif
                    next2:
                    inc c
                    ld de,unitSize
                    add ix,de
                dwnz
            pop ix | pop bc | pop hl
            ld de,600
            add hl,de
        endif
        ld (time),hl
    pop de | pop hl | pop af
ret

MelodyWait:
    di
    ld (Channels+unitSize*0+Channel_Ptr),hl
    ld a,1
    ld (Channels+unitSize*0+Channel_Len),a
    ei
    do
        ld hl,(Channels+unitSize*0+Channel_Ptr)
        ld a,l
        or h
    while nz | wend
ret 

C2 equ 1
D2 equ 3
E2 equ 5
F2 equ 6
G2 equ 8
A2 equ 10

C4 equ 25
D4 equ 27
E4 equ 29
F4 equ 30
G4 equ 32
A4 equ 34
B4 equ 36
C5 equ 37


start_notes: defb 3,C4, 3,G4, 3,E4, 3,G4, 12,C5, 0
Sound_Start_: public Sound_Start_
    push af | push hl
        ld hl,start_notes
        call MelodyWait
    pop hl | pop af
ret

clear_notes: defb 3,C4, 3,E4, 3,G4, 3,D4, 3,F4, 3,A4, 3,E4, 3,G4, 3,B4, 9,C5,0
Sound_Clear_: public Sound_Clear_
    push af | push hl
        ld hl,clear_notes
        call MelodyWait
    pop hl | pop af
ret

over_notes: defb 3,C5, 3,G4, 3,E4, 3,C5,  3,B4, 3,G4, 3,E4, 3,B4,  6,A4, 6,B4,  12,C5, 0
Sound_GameOver_: public Sound_GameOver_
    push af | push hl
        ld hl,over_notes
        call MelodyWait
    pop hl | pop af
ret


BGM_B: 
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 18,A4
    defb 3,D4, 3,F4, 3,G4
    defb 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4, 3,A4
    defb 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,G4, 3,A4, 3,G4
    defb 12,F4, 12,G4, 18,F4
    defb 0ffh
BGM_C: 
    defb 9,0
    defb 9,F2, 9,F2, 6,F2
    defb 9,C2, 9,C2, 6,C2
    defb 12,F2, 12,G2, 18,A2, 9,0
    defb 9,A2, 9,A2, 6,A2
    defb 9,G2, 9,G2, 6,G2
    defb 12,F2, 12,C2, 18,F2
    ; defb 6,F2+Bass, 3,0, 6,F2+Bass, 3,0, 6,F2+Bass
    ; defb 6,C2+Bass, 3,0, 6,C2+Bass, 3,0, 6,C2+Bass
    ; defb 9,F2+Bass, 3,0, 9,G2+Bass, 3,0, 12,A2+Bass, 15,0
    ; defb 6,A2+Bass, 3,0, 6,A2+Bass, 3,0, 6,A2+Bass
    ; defb 6,G2+Bass, 3,0, 6,G2+Bass, 3,0, 6,G2+Bass
    ; defb 9,F2+Bass, 3,0, 9,C2+Bass, 3,0, 12,F2+Bass, 6,0
    defb 0ffh
BGM_D: 
    defb 3,A4, 3,A4, 3,A4
    defb 6,0, 6,A4, 6,0, 6,A4  
    defb 6,0, 6,A4, 6,0, 6,A4
    defb 6,0, 6,A4, 6,0, 6,A4, 6,0, 3,A4, 3,A4, 3,0, 3,A4
    defb 0ffh
; BGM_BD:
;     defb 9,0
;     defb 6,A2, 3,0, 3,A2, 6,A2, 6,0
;     defb 6,A2, 3,0, 3,A2, 6,A2, 6,0
;     defb 6,A2, 6,0, 6,A2, 6,0, 6,A2, 18,0, 9,0
;     defb 6,A2, 3,0, 3,A2, 6,A2, 6,0
;     defb 6,A2, 3,0, 3,A2, 6,A2, 6,0
;     defb 6,A2, 6,0, 6,A2, 6,0, 6,A2, 18,0
;     defb 0ffh

StartBGM_: public StartBGM_
    push af | push hl
        di
            ld a,1
            ld hl,BGM_B
            ld (Channels+unitSize*1+Channel_Start),hl
            ld (Channels+unitSize*1+Channel_Ptr),hl
            ld (Channels+unitSize*1+Channel_Len),a
            ld hl,BGM_C
            ld (Channels+unitSize*2+Channel_Start),hl
            ld (Channels+unitSize*2+Channel_Ptr),hl
            ld (Channels+unitSize*2+Channel_Len),a
            ld hl,BGM_D
            ld (Channels+unitSize*5+Channel_Start),hl
            ld (Channels+unitSize*5+Channel_Ptr),hl
            ld (Channels+unitSize*5+Channel_Len),a
            ; ld hl,BGM_BD
            ; ld (Channels+unitSize*3+Channel_Start),hl
            ; ld (Channels+unitSize*3+Channel_Ptr),hl
            ; ld (Channels+unitSize*3+Channel_Len),a
        ei
    pop hl | pop af
ret

StopBGM_: public StopBGM_
    push af | push hl | push bc
        di
            ld hl,0
            ld (Channels+unitSize*2+Channel_Ptr),hl
            ld (Channels+unitSize*1+Channel_Ptr),hl
            ld (Channels+unitSize*5+Channel_Ptr),hl
            ; ld (Channels+unitSize*3+Channel_Ptr),hl
            ld bc,2*256 or Psg_Volume_B
            do
                ld a,c
                out (Port_Register),a
                xor a
                out (Port_Out),a
                inc c
            dwnz
            ld bc,300h
            do
                call WaitPort
                ld a,Opn_OnOff
                out (Port_Register),a
                ld a,(0)
                ld a,c
                out (Port_Out),a
                inc c
            dwnz
        ei
    pop bc | pop hl | pop af
ret


cycles:
defw 1908 ; C2
defw 1800 ; C#2
defw 1699 ; D2
defw 1604 ; D#2
defw 1514 ; E2
defw 1429 ; F2
defw 1349 ; F#2
defw 1273 ; G2
defw 1202 ; G#2
defw 1134 ; A2
defw 1070 ; A#2
defw 1010 ; B2
defw 954 ; C3
defw 900 ; C#3
defw 849 ; D3
defw 802 ; D#3
defw 757 ; E3
defw 714 ; F3
defw 674 ; F#3
defw 636 ; G3
defw 601 ; G#3
defw 567 ; A3
defw 535 ; A#3
defw 505 ; B3
defw 477 ; C4
defw 450 ; C#4
defw 424 ; D4
defw 401 ; D#4
defw 378 ; E4
defw 357 ; F
defw 337 ; F#4
defw 318 ; G4
defw 300 ; G#4
defw 283 ; A4
defw 267 ; A#4
defw 252 ; B4
defw 238 ; C5

OpnScales:
defb 10,106 ; C2
defb 10,143 ; C#2
defb 10,182 ; D2
defb 10,223 ; D#2
defb 11,11 ; E2
defb 11,57 ; F2
defb 11,106 ; F#2
defb 11,158 ; G2
defb 11,213 ; G#2
defb 12,16 ; A2
defb 12,78 ; A#2
defb 12,143 ; B2

defb 18,106 ; C3
defb 18,143 ; C#3
defb 18,182 ; D3
defb 18,223 ; D#3
defb 19,11 ; E3
defb 19,57 ; F3
defb 19,106 ; F#3
defb 19,158 ; G3
defb 19,213 ; G#3
defb 20,16 ; A3
defb 20,78 ; A#3
defb 20,143 ; B3

defb 26,106 ; C4
defb 26,143 ; C#4
defb 26,182 ; D4
defb 26,223 ; D#4
defb 27,11 ; E4
defb 27,57 ; F4
defb 27,106 ; F#4
defb 27,158 ; G4
defb 27,213 ; G#4
defb 28,16 ; A4
defb 28,78 ; A#4
defb 28,143 ; B4

defb 34,106 ; C5
