include "FixedCode.inc"
include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

public WriteVram

Port31Save equ 0e658h
Port33Save equ 0e669h

ext VVram_

dseg
Backup:
    defs VVramWidth*VVramHeight

cseg
ToRam:
    push af
        ld a,(Port31Save)
        or 02h
        out (31h),a
        ld (Port31Save),a
    pop af
ret

ToRom:
    push af
        ld a,(Port31Save)
        and not 02h
        out (31h),a
        ld (Port31Save),a
    pop af
ret

PatternAddress:
    push de
        ld l,a
        ld h,0
        ld e,l
        ld d,h
        add hl,hl ;*2
        add hl,de ;*3
        add hl,hl ;*6
        add hl,hl ;*12
        add hl,hl ;*24
        ld de,PatternRam
        add hl,de
    pop de
ret


; void MakePatternMono(byte c, ptr<byte> pSource, byte count, byte color);
dseg
    MakePatternMono_@Param3: public MakePatternMono_@Param3
    defb 0
cseg
MakePatternMono_: public MakePatternMono_
    push af | push hl | push de | push bc
        di
            call ToRam
            call PatternAddress
            do
                push bc
                    ld a,(MakePatternMono_@Param3) ; color
                    exx
                        ld d,a
                    exx
                    ld c,3
                    do
                        push de
                            ld b,8
                            do
                                exx
                                    bit 0,d
                                exx
                                if nz
                                    ld a,(de)
                                else
                                    xor a
                                endif
                                inc de
                                ld (hl),a
                                inc hl
                            dwnz
                        pop de
                        exx
                            srl d
                        exx
                        dec c
                    while nz | wend
                    ex de,hl
                        ld bc,8
                        add hl,bc
                    ex de,hl
                pop bc
                dec c
            while nz | wend
                                _deb: public _deb
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void MakePatternColor(byte c, ptr<byte> pSource, byte count);
MakePatternColor_: public MakePatternColor_
    push af | push hl | push de | push bc
        di
            call ToRam
            call PatternAddress
            do
                ld b,24
                do
                    ld a,(de)
                    inc de
                    ld (hl),a
                    inc hl
                dwnz
                dec c
            while nz | wend
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void InitOffscreen();
InitOffscreen_: public InitOffscreen_
    push af | push hl | push de | push bc
        di
            call ToRam
                call InitOffscreen
            call ToRom
        ei
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
ClearScreen_:   public ClearScreen_
    push af | push hl | push de | push bc
        call ClearVram

        ld hl,Backup
        ld de,Backup+1
        ld bc,VVramWidth*VVramHeight*2-1
        ld (hl),0
        ldir
    pop bc | pop de | pop hl | pop af
ret



; word Put(word vram, byte c);
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        or a
        if z
            ld de,Offscreen
            jr Put_offscreen
        endif
        cp Char_Wall
        if z
            ld de,Offscreen+CharHeight
            Put_offscreen:
            di
                call FromOffscreen
            ei
            jr Put_exit
        endif
        ex de,hl
            call PatternAddress
        ex de,hl
        di
            call ToRam
            call WriteVram
            call ToRom
        ei
        Put_exit:
    pop bc | pop de | pop hl | pop af
    inc hl
ret


; void VVramToVram();
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,Backup
        exx
            ld hl,Vram
        exx
        ld c, VVramHeight
        do
        ld b,VVramWidth
            do 
                push bc 
                    ld a,(de)
                    inc de
                    cp (hl)
                    if nz
                        ld (hl),a
                        exx
                            push de
                                ld e,a
                                call Put_
                            pop de
                        exx
                    else
                        exx
                            inc hl
                        exx
                    endif
                    inc hl
                pop bc
            dwnz
            exx
                push bc
                    ld bc,VramRowSize-VVramWidth
                    add hl,bc
                pop bc
            exx
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
